
-- Get part numbers for parts supplied to any project in London.
SELECT DISTINCT SPJ.PID
FROM   SPJ, J
WHERE  SPJ.JID = J.JID
AND    J.CITY = 'London' ;

-- syntax error to separate results
?;

-- Get part numbers for parts supplied to all projects in London.
SELECT P.PID
FROM   P
WHERE  NOT EXISTS
     ( SELECT *
       FROM   J
       WHERE  J.CITY = 'London'
       AND    NOT EXISTS
           ( SELECT *
             FROM   SPJ
             WHERE  SPJ.PID = P.PID
             AND    SPJ.JID = J.JID ) ) ;
